Initial ARM support

Initial ARM support
This commit is contained in:
Kroese 2023-05-24 23:28:34 +02:00 committed by GitHub
commit 0ac93a8c7c
3 changed files with 45 additions and 28 deletions

View File

@ -10,11 +10,12 @@ DL="https://global.synologydownload.com/download/DSM"
if [ -z "$URL" ]; then
URL="$DL/release/7.2/64561/DSM_VirtualDSM_64561.pat"
#URL="$DL/release/7.0.1/42218/DSM_VirtualDSM_42218.pat"
#URL="$DL/release/7.1.1/42962-1/DSM_VirtualDSM_42962.pat"
fi
[ "$ARCH" != "amd64" ] && URL="$DL/release/7.0.1/42218/DSM_VirtualDSM_42218.pat"
# Check if output is to interactive TTY
if [ -t 1 ]; then
PROGRESS="--progress=bar:noscroll"
@ -36,7 +37,7 @@ rm -rf "$TMP" && mkdir -p "$TMP"
[[ "${DEBUG}" == [Yy1]* ]] && set -x
if [ ! -f "${RDC}" ]; then
if [ ! -f "${RDC}" ] && [ "$ARCH" == "amd64" ]; then
info "Install: Downloading installer..."
@ -68,14 +69,16 @@ if [ ! -f "${RDC}" ]; then
fi
{ xz -dc <"$RDC" >"$TMP/rd" 2>/dev/null; rc=$?; } || :
(( rc != 1 )) && error "Failed to unxz $RDC, reason $rc" && exit 91
if [ -f "${RDC}" ] && [ "$ARCH" == "amd64" ]; then
{ (cd "$TMP" && cpio -idm <"$TMP/rd" 2>/dev/null); rc=$?; } || :
(( rc != 0 )) && error "Failed to cpio $RDC, reason $rc" && exit 92
{ xz -dc <"$RDC" >"$TMP/rd" 2>/dev/null; rc=$?; } || :
(( rc != 1 )) && error "Failed to unxz $RDC, reason $rc" && exit 91
mkdir -p /run/extract
for file in $TMP/usr/lib/libcurl.so.4 \
{ (cd "$TMP" && cpio -idm <"$TMP/rd" 2>/dev/null); rc=$?; } || :
(( rc != 0 )) && error "Failed to cpio $RDC, reason $rc" && exit 92
mkdir -p /run/extract
for file in $TMP/usr/lib/libcurl.so.4 \
$TMP/usr/lib/libmbedcrypto.so.5 \
$TMP/usr/lib/libmbedtls.so.13 \
$TMP/usr/lib/libmbedx509.so.1 \
@ -84,12 +87,14 @@ for file in $TMP/usr/lib/libcurl.so.4 \
$TMP/usr/lib/libsynocodesign-ng-virtual-junior-wins.so.7 \
$TMP/usr/syno/bin/scemd; do
cp "$file" /run/extract/
done
done
mv /run/extract/scemd /run/extract/syno_extract_system_patch
chmod +x /run/extract/syno_extract_system_patch
mv /run/extract/scemd /run/extract/syno_extract_system_patch
chmod +x /run/extract/syno_extract_system_patch
rm -rf "$TMP" && mkdir -p "$TMP"
rm -rf "$TMP" && mkdir -p "$TMP"
fi
info "Install: Downloading $(basename "$URL")..."
@ -110,12 +115,18 @@ fi
info "Install: Extracting downloaded image..."
if { tar tf "$PAT"; } >/dev/null 2>&1; then
tar xpf "$PAT" -C "$TMP/."
else
[ "$ARCH" != "amd64" ] && error "Wrong architecture: $ARCH" && exit 65
export LD_LIBRARY_PATH="/run/extract"
{ /run/extract/syno_extract_system_patch "$PAT" "$TMP/."; rc=$?; } || :
(( rc != 0 )) && error "Failed to extract PAT file, reason $rc" && exit 63
export LD_LIBRARY_PATH=""
fi
HDA="$TMP/hda1"

View File

@ -62,8 +62,10 @@ else
fi
if [ -n "${KVM_ERR}" ]; then
if [ "$ARCH" == "amd64" ]; then
error "KVM acceleration not detected ${KVM_ERR}, see the FAQ about this."
[[ "${DEBUG}" != [Yy1]* ]] && exit 88
fi
else
KVM_OPTS=",accel=kvm -enable-kvm -cpu host"
fi

View File

@ -18,7 +18,11 @@ fi
if [ -n "$HOST_CPU" ]; then
HOST_CPU="$HOST_CPU,,"
else
if [ "$ARCH" == "amd64" ]; then
HOST_CPU="QEMU, Virtual CPU, X86_64"
else
HOST_CPU="QEMU, Virtual CPU, $ARCH"
fi
fi
HOST_ARGS=()